function [ status, cdata, runningTime ] = wrapper_ACC( param, cdata )
%% wrapper func of Agglomarative Correspondence Clustering

% make singleton clusters
for i=1:cdata.nInitialMatches
    cdata.matchInfo(i).isOff = 0;
    cdata.matchInfo(i).isInitialMatch = 1;
    cdata.matchInfo(i).latentIdx = 0;
    curMatch = cdata.matchInfo(i).match;
    if cdata.bPair
        cdata.matchInfo(i).dSIFT = sqrt( sum((cdata.view(1).desc(curMatch(1)) - cdata.view(2).desc(curMatch(2))).^2 ));
    else
        cdata.matchInfo(i).dSIFT = sqrt( sum((cdata.view(1).desc(curMatch(1)) - cdata.view(1).desc(curMatch(2))).^2 ));
    end
    cdata.matchInfo(i).clusterId = i; % cluster ID this belonging to
    cdata.matchInfo(i).supporterIdx = 0; % idx of supporter match
    cdata.matchInfo(i).seedIdx = i; % idx of origin seed
    cdata.matchInfo(i).nSupporting = 0; % times of supporting
end

%% Constructing initial grown seed and cluster information
%feat(:,1:7) : 1-5:xyabc 6:d.o.(radian) 7:determinant

%disp('== Constructing initial cluster information...');
cdata.nSeed = cdata.nInitialMatches;
%
% clusterInfo(:).id                 : id of the cluster i.e. 1, 2, 3,...
% clusterInfo(:).color              : color of the cluster as RGB values [ R G B ]
% clusterInfo(:).matchIdx           : a set of indexes of matches in the cluster
% clusterInfo(:).size               : the size of match set
% clusterInfo(:).centroid           : the centroid of the cluster

for i=1:cdata.nInitialMatches
    cdata.clusterInfo(i).id = i; % unique id of this cluster
    cdata.clusterInfo(i).matchIdx = [ i ]; %  seed idx contained in this cluster
    % head 1: first - head, second - tail
    % head 2: first - tail, second - head
    cdata.clusterInfo(i).headOfMatch = [ 1 ];  % already aligned..(?)
    cdata.clusterInfo(i).flipOfMatch = [ 0 ];

    cdata.clusterInfo(i).size = 1; % total grown match size in this cluster
    cdata.clusterInfo(i).color = rand(1,3); % color of this cluster

    tmpMatch = cdata.matchInfo(i).match;
    if cdata.clusterInfo(i).headOfMatch == 1
        if cdata.bPair
            % 2 view
            cdata.clusterInfo(i).centroid_head = [ cdata.view(1).feat(tmpMatch(1),1:2) ]; % because the base is head
            cdata.clusterInfo(i).centroid_tail = [ cdata.view(2).feat(tmpMatch(2),1:2) ]; % because the base is head
        else
            % 1 view
            cdata.clusterInfo(i).centroid_head = [ cdata.view(1).feat(tmpMatch(1),1:2) ]; % because the base is tail
            cdata.clusterInfo(i).centroid_tail = [ cdata.view(1).feat(tmpMatch(2),1:2) ]; % because the base is tail
        end
    else
        if cdata.bPair
            % 2 view
            cdata.clusterInfo(i).centroid_tail = [ cdata.view(1).feat(tmpMatch(1),1:2) ]; % because the base is head
            cdata.clusterInfo(i).centroid_head = [ cdata.view(2).feat(tmpMatch(2),1:2) ]; % because the base is head
        else
            % 1 view 
            cdata.clusterInfo(i).centroid_tail = [ cdata.view(1).feat(tmpMatch(1),1:2) ]; % because the base is head
            cdata.clusterInfo(i).centroid_head = [ cdata.view(1).feat(tmpMatch(2),1:2) ]; % because the base is head
        end
    end
end

cdata.nCluster = cdata.nInitialMatches;
cdata.newClusterId = cdata.nCluster+1;

%% run the main algorithm
status = [];
tic;
[ cdata ] = agglomerate_corres_v12( param, cdata );
runningTime = toc;




            
